library ieee;
use ieee.std_logic_1164.all;
package numeric_std is
 constant copyrightnotice : string := "Copyright 1995 IEEE. All rights reserved.";
type unsigned is array  ( natural range <> )  of std_logic;
type signed is array  ( natural range <> )  of std_logic;
function "abs" (constant arg : in signed) return signed;
function "-" (constant arg : in signed) return signed;
function "+" (constant l : in unsigned; constant r : in unsigned) return unsigned;
function "+" (constant l : in signed; constant r : in signed) return signed;
function "+" (constant l : in unsigned; constant r : in natural) return unsigned;
function "+" (constant l : in natural; constant r : in unsigned) return unsigned;
function "+" (constant l : in integer; constant r : in signed) return signed;
function "+" (constant l : in signed; constant r : in integer) return signed;
function "-" (constant l : in unsigned; constant r : in unsigned) return unsigned;
function "-" (constant l : in signed; constant r : in signed) return signed;
function "-" (constant l : in unsigned; constant r : in natural) return unsigned;
function "-" (constant l : in natural; constant r : in unsigned) return unsigned;
function "-" (constant l : in signed; constant r : in integer) return signed;
function "-" (constant l : in integer; constant r : in signed) return signed;
function "*" (constant l : in unsigned; constant r : in unsigned) return unsigned;
function "*" (constant l : in signed; constant r : in signed) return signed;
function "*" (constant l : in unsigned; constant r : in natural) return unsigned;
function "*" (constant l : in natural; constant r : in unsigned) return unsigned;
function "*" (constant l : in signed; constant r : in integer) return signed;
function "*" (constant l : in integer; constant r : in signed) return signed;
function "/" (constant l : in unsigned; constant r : in unsigned) return unsigned;
function "/" (constant l : in signed; constant r : in signed) return signed;
function "/" (constant l : in unsigned; constant r : in natural) return unsigned;
function "/" (constant l : in natural; constant r : in unsigned) return unsigned;
function "/" (constant l : in signed; constant r : in integer) return signed;
function "/" (constant l : in integer; constant r : in signed) return signed;
function "rem" (constant l : in unsigned; constant r : in unsigned) return unsigned;
function "rem" (constant l : in signed; constant r : in signed) return signed;
function "rem" (constant l : in unsigned; constant r : in natural) return unsigned;
function "rem" (constant l : in natural; constant r : in unsigned) return unsigned;
function "rem" (constant l : in signed; constant r : in integer) return signed;
function "rem" (constant l : in integer; constant r : in signed) return signed;
function "mod" (constant l : in unsigned; constant r : in unsigned) return unsigned;
function "mod" (constant l : in signed; constant r : in signed) return signed;
function "mod" (constant l : in unsigned; constant r : in natural) return unsigned;
function "mod" (constant l : in natural; constant r : in unsigned) return unsigned;
function "mod" (constant l : in signed; constant r : in integer) return signed;
function "mod" (constant l : in integer; constant r : in signed) return signed;
function ">" (constant l : in unsigned; constant r : in unsigned) return boolean;
function ">" (constant l : in signed; constant r : in signed) return boolean;
function ">" (constant l : in natural; constant r : in unsigned) return boolean;
function ">" (constant l : in integer; constant r : in signed) return boolean;
function ">" (constant l : in unsigned; constant r : in natural) return boolean;
function ">" (constant l : in signed; constant r : in integer) return boolean;
function "<" (constant l : in unsigned; constant r : in unsigned) return boolean;
function "<" (constant l : in signed; constant r : in signed) return boolean;
function "<" (constant l : in natural; constant r : in unsigned) return boolean;
function "<" (constant l : in integer; constant r : in signed) return boolean;
function "<" (constant l : in unsigned; constant r : in natural) return boolean;
function "<" (constant l : in signed; constant r : in integer) return boolean;
function "<=" (constant l : in unsigned; constant r : in unsigned) return boolean;
function "<=" (constant l : in signed; constant r : in signed) return boolean;
function "<=" (constant l : in natural; constant r : in unsigned) return boolean;
function "<=" (constant l : in integer; constant r : in signed) return boolean;
function "<=" (constant l : in unsigned; constant r : in natural) return boolean;
function "<=" (constant l : in signed; constant r : in integer) return boolean;
function ">=" (constant l : in unsigned; constant r : in unsigned) return boolean;
function ">=" (constant l : in signed; constant r : in signed) return boolean;
function ">=" (constant l : in natural; constant r : in unsigned) return boolean;
function ">=" (constant l : in integer; constant r : in signed) return boolean;
function ">=" (constant l : in unsigned; constant r : in natural) return boolean;
function ">=" (constant l : in signed; constant r : in integer) return boolean;
function "=" (constant l : in unsigned; constant r : in unsigned) return boolean;
function "=" (constant l : in signed; constant r : in signed) return boolean;
function "=" (constant l : in natural; constant r : in unsigned) return boolean;
function "=" (constant l : in integer; constant r : in signed) return boolean;
function "=" (constant l : in unsigned; constant r : in natural) return boolean;
function "=" (constant l : in signed; constant r : in integer) return boolean;
function "/=" (constant l : in unsigned; constant r : in unsigned) return boolean;
function "/=" (constant l : in signed; constant r : in signed) return boolean;
function "/=" (constant l : in natural; constant r : in unsigned) return boolean;
function "/=" (constant l : in integer; constant r : in signed) return boolean;
function "/=" (constant l : in unsigned; constant r : in natural) return boolean;
function "/=" (constant l : in signed; constant r : in integer) return boolean;
function shift_left (constant arg : in unsigned; constant count : in natural) return unsigned;
function shift_right (constant arg : in unsigned; constant count : in natural) return unsigned;
function shift_left (constant arg : in signed; constant count : in natural) return signed;
function shift_right (constant arg : in signed; constant count : in natural) return signed;
function rotate_left (constant arg : in unsigned; constant count : in natural) return unsigned;
function rotate_right (constant arg : in unsigned; constant count : in natural) return unsigned;
function rotate_left (constant arg : in signed; constant count : in natural) return signed;
function rotate_right (constant arg : in signed; constant count : in natural) return signed;
function "sll" (constant arg : in unsigned; constant count : in integer) return unsigned;
function "sll" (constant arg : in signed; constant count : in integer) return signed;
function "srl" (constant arg : in unsigned; constant count : in integer) return unsigned;
function "srl" (constant arg : in signed; constant count : in integer) return signed;
function "rol" (constant arg : in unsigned; constant count : in integer) return unsigned;
function "rol" (constant arg : in signed; constant count : in integer) return signed;
function "ror" (constant arg : in unsigned; constant count : in integer) return unsigned;
function "ror" (constant arg : in signed; constant count : in integer) return signed;
function resize (constant arg : in signed; constant new_size : in natural) return signed;
function resize (constant arg : in unsigned; constant new_size : in natural) return unsigned;
function to_integer (constant arg : in unsigned) return natural;
function to_integer (constant arg : in signed) return integer;
function to_unsigned (constant arg : in natural; constant size : in natural) return unsigned;
function to_signed (constant arg : in integer; constant size : in natural) return signed;
function "not" (constant l : in unsigned) return unsigned;
function "and" (constant l : in unsigned; constant r : in unsigned) return unsigned;
function "or" (constant l : in unsigned; constant r : in unsigned) return unsigned;
function "nand" (constant l : in unsigned; constant r : in unsigned) return unsigned;
function "nor" (constant l : in unsigned; constant r : in unsigned) return unsigned;
function "xor" (constant l : in unsigned; constant r : in unsigned) return unsigned;
function "xnor" (constant l : in unsigned; constant r : in unsigned) return unsigned;
function "not" (constant l : in signed) return signed;
function "and" (constant l : in signed; constant r : in signed) return signed;
function "or" (constant l : in signed; constant r : in signed) return signed;
function "nand" (constant l : in signed; constant r : in signed) return signed;
function "nor" (constant l : in signed; constant r : in signed) return signed;
function "xor" (constant l : in signed; constant r : in signed) return signed;
function "xnor" (constant l : in signed; constant r : in signed) return signed;
function std_match (constant l : in std_ulogic; constant r : in std_ulogic) return boolean;
function std_match (constant l : in unsigned; constant r : in unsigned) return boolean;
function std_match (constant l : in signed; constant r : in signed) return boolean;
function std_match (constant l : in std_logic_vector; constant r : in std_logic_vector) return boolean;
function std_match (constant l : in std_ulogic_vector; constant r : in std_ulogic_vector) return boolean;
function to_01 (constant s : in unsigned; constant xmap : in std_logic := '0') return unsigned;
function to_01 (constant s : in signed; constant xmap : in std_logic := '0') return signed;
end package;
